#!/bin/bash

export BC_LINE_LENGTH=200

p=2

x=$1

digits=$2

inverse=1

last_digit=$(echo -e "$x % 2" | bc -q)

if [[ $last_digit == 0 ]]
then
    echo "error: argument must be of the form 2n+1"
    exit 1
fi

while :
do
  inverse_base_2=$(echo -e "obase=2 \n $inverse" | bc -q)

  printf "%${digits}s %s\n" $inverse_base_2 $inverse

  result=$(echo -e "obase=2 \n $x*$inverse - 1" | bc -q)

  zeros=$(echo "$result" | awk '{s=length($0); sub("0+$",""); t=length($0); print s-t;}')

  [[ $zeros -ge $digits ]] && exit

  incr=$(echo "2 ^ $zeros" | bc -q)

  inverse=$(echo "$inverse + $incr" | bc -q)
done
