#!/bin/bash

export BC_LINE_LENGTH=200

p=5

target=$1

digits=$2

sqrt=1

position=1

while :
do
  [[ $position -eq $digits ]] && break

  sqrt_base_p=$(echo -e "obase=$p \n $sqrt" | bc -q)

  sqr_base_p=$(echo -e "obase=$p \n $sqrt * $sqrt" | bc -q)

  printf "%${digits}s %$((digits * 2))s\n" $sqrt_base_p $sqr_base_p

  offset=0

  while :
  do
    d=$(echo "(($sqrt*$sqrt - $target + $offset * ($p^($position+1))) % ($p^($position+1)))/($p^$position) " | bc -q)

    offset=$((offset+1))

    [[ $d -ge 0 ]] && break
  done

  [[ $d == 0 ]] && new_digit=0
  [[ $d == 1 ]] && new_digit=2
  [[ $d == 2 ]] && new_digit=4
  [[ $d == 3 ]] && new_digit=1
  [[ $d == 4 ]] && new_digit=3

  incr=$(echo "$new_digit * ($p ^ $position)" | bc -q)

  sqrt=$((sqrt+incr))

  position=$((position + 1))
done

echo "sqrt($target) ~ $sqrt"
