#!/bin/perl

# Sqrt(17) = ...1,011,101,001 = ...512+128+64+32+8+1 = ...745

$power_of_two = $ARGV[0];

$sqrt_17=1255145;
$i_lim=2 ** $power_of_two;

$x_min=100;
$y_min=100;

$x_max=500;
$y_max=500;

$y_inc=1/$i_lim;
$x_inc=1-(($sqrt_17%$i_lim) * $y_inc);

$x_inc*=400;
$y_inc*=400;

$x=$x_min;
$y=$y_min;

print "%!PS

newpath
 100  100  moveto
   0  400 rlineto
 400    0 rlineto
   0 -400 rlineto
-400    0 rlineto
closepath
4 setlinewidth
stroke

";

for ($i=0; $i<$i_lim; ++$i)
{
    $j=$i;
    $k=0;
    while ($j>0 && $j%2==0)
    {
	$j=$j/2;
	++$k
    }
    $d=0.5+$k/4;
    print "$x $y $d 0 360 arc fill\n";
    $x=$x+$x_inc;
    $y=$y+$y_inc;
    $x=$x-$x_max+$x_min if ($x >= $x_max);
    $y=$y-$y_max+$y_min if ($y >= $y_max);
}

print "
showpage
";
